/*******************************************************
 ***
 ***      Arithmetic Interpreter        Version 2.2
 ***
 ***                    C Version
 ***
 *******************************************************/
 
#ifndef __INTERPRETER__
#define __INTERPRETER__

#define PI 3.141592654

typedef struct CNode {
  short operator_;
  float val;
  struct CNode *fg,*fd;
} CNode;

char * CopyPartialString(char *,short,short);

void FindOperator(short * ,short * ,char *,short);
float CalcValue(char *,short);

void ConstructTree(CNode *,char *,short,short *);
float ComputeTree(CNode *,float,float,short *);
float PuisInt(float ,short);
CNode * NewNode(void);
void DeleteNode(CNode *);
CNode * CopyNode(CNode *);

/* fonctions pour la derivation symbolique */

CNode * Deriv_fpg_arbre(CNode *); /* calcul de f'*g */
CNode * Deriv_fgp_arbre(CNode *); /* calcul de f*g' */
CNode * Deriv_frac_num(CNode *);  /* calcul de f'*g-f*g' */
CNode * Deriv_frac_den(CNode *);  /* calcul de g^2 */
CNode * Deriv_arbre(CNode *);

/* Ecriture formatee d'une expression */

void WriteTree(CNode *,char *);

#endif
